#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include <lber.h>
#include <ldap.h>

#ifdef NETSCAPE_LDAP
 #define LDAP_CHAR const char
#else
 #define LDAP_CHAR char
#endif

static int
not_here(s)
char *s;
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

static double
constant(name, arg)
char *name;
int arg;
{
    errno = 0;
    switch (*name) {
    case 'A':
	break;
    case 'B':
	break;
    case 'C':
	break;
    case 'D':
	break;
    case 'E':
	break;
    case 'F':
	if (strEQ(name, "FD_SETSIZE"))
#ifdef FD_SETSIZE
	    return FD_SETSIZE;
#else
	    goto not_there;
#endif
	break;
    case 'G':
	break;
    case 'H':
	break;
    case 'I':
	break;
    case 'J':
	break;
    case 'K':
	break;
    case 'L':
	if (strEQ(name, "LDAPS_PORT"))
#ifdef LDAPS_PORT
	    return LDAPS_PORT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_ADMIN_LIMIT_EXCEEDED"))
#ifdef LDAP_ADMIN_LIMIT_EXCEEDED
	    return LDAP_ADMIN_LIMIT_EXCEEDED;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_AFFECTS_MULTIPLE_DSAS"))
#ifdef LDAP_AFFECTS_MULTIPLE_DSAS
	    return LDAP_AFFECTS_MULTIPLE_DSAS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_ALIAS_DEREF_PROBLEM"))
#ifdef LDAP_ALIAS_DEREF_PROBLEM
	    return LDAP_ALIAS_DEREF_PROBLEM;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_ALIAS_PROBLEM"))
#ifdef LDAP_ALIAS_PROBLEM
	    return LDAP_ALIAS_PROBLEM;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_ALREADY_EXISTS"))
#ifdef LDAP_ALREADY_EXISTS
	    return LDAP_ALREADY_EXISTS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_AUTH_NONE"))
#ifdef LDAP_AUTH_NONE
	    return LDAP_AUTH_NONE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_AUTH_SIMPLE"))
#ifdef LDAP_AUTH_SIMPLE
	    return LDAP_AUTH_SIMPLE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_AUTH_UNKNOWN"))
#ifdef LDAP_AUTH_UNKNOWN
	    return LDAP_AUTH_UNKNOWN;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_BUSY"))
#ifdef LDAP_BUSY
	    return LDAP_BUSY;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_C"))
#ifdef LDAP_C
	    return LDAP_C;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_CACHE_CHECK"))
#ifdef LDAP_CACHE_CHECK
	    return LDAP_CACHE_CHECK;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_CACHE_LOCALDB"))
#ifdef LDAP_CACHE_LOCALDB
	    return LDAP_CACHE_LOCALDB;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_CACHE_POPULATE"))
#ifdef LDAP_CACHE_POPULATE
	    return LDAP_CACHE_POPULATE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_CALL"))
#ifdef LDAP_CALL
	    return LDAP_CALL;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_CALLBACK"))
#ifdef LDAP_CALLBACK
	    return LDAP_CALLBACK;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_COMPARE_FALSE"))
#ifdef LDAP_COMPARE_FALSE
	    return LDAP_COMPARE_FALSE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_COMPARE_TRUE"))
#ifdef LDAP_COMPARE_TRUE
	    return LDAP_COMPARE_TRUE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_CONNECT_ERROR"))
#ifdef LDAP_CONNECT_ERROR
	    return LDAP_CONNECT_ERROR;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_CONSTRAINT_VIOLATION"))
#ifdef LDAP_CONSTRAINT_VIOLATION
	    return LDAP_CONSTRAINT_VIOLATION;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_DECODING_ERROR"))
#ifdef LDAP_DECODING_ERROR
	    return LDAP_DECODING_ERROR;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_DEREF_ALWAYS"))
#ifdef LDAP_DEREF_ALWAYS
	    return LDAP_DEREF_ALWAYS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_DEREF_FINDING"))
#ifdef LDAP_DEREF_FINDING
	    return LDAP_DEREF_FINDING;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_DEREF_NEVER"))
#ifdef LDAP_DEREF_NEVER
	    return LDAP_DEREF_NEVER;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_DEREF_SEARCHING"))
#ifdef LDAP_DEREF_SEARCHING
	    return LDAP_DEREF_SEARCHING;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_ENCODING_ERROR"))
#ifdef LDAP_ENCODING_ERROR
	    return LDAP_ENCODING_ERROR;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_FILTER_ERROR"))
#ifdef LDAP_FILTER_ERROR
	    return LDAP_FILTER_ERROR;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_FILT_MAXSIZ"))
#ifdef LDAP_FILT_MAXSIZ
	    return LDAP_FILT_MAXSIZ;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_INAPPROPRIATE_AUTH"))
#ifdef LDAP_INAPPROPRIATE_AUTH
	    return LDAP_INAPPROPRIATE_AUTH;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_INAPPROPRIATE_MATCHING"))
#ifdef LDAP_INAPPROPRIATE_MATCHING
	    return LDAP_INAPPROPRIATE_MATCHING;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_INSUFFICIENT_ACCESS"))
#ifdef LDAP_INSUFFICIENT_ACCESS
	    return LDAP_INSUFFICIENT_ACCESS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_INVALID_CREDENTIALS"))
#ifdef LDAP_INVALID_CREDENTIALS
	    return LDAP_INVALID_CREDENTIALS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_INVALID_DN_SYNTAX"))
#ifdef LDAP_INVALID_DN_SYNTAX
	    return LDAP_INVALID_DN_SYNTAX;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_INVALID_SYNTAX"))
#ifdef LDAP_INVALID_SYNTAX
	    return LDAP_INVALID_SYNTAX;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_IS_LEAF"))
#ifdef LDAP_IS_LEAF
	    return LDAP_IS_LEAF;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_LOCAL_ERROR"))
#ifdef LDAP_LOCAL_ERROR
	    return LDAP_LOCAL_ERROR;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_LOOP_DETECT"))
#ifdef LDAP_LOOP_DETECT
	    return LDAP_LOOP_DETECT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_MOD_ADD"))
#ifdef LDAP_MOD_ADD
	    return LDAP_MOD_ADD;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_MOD_BVALUES"))
#ifdef LDAP_MOD_BVALUES
	    return LDAP_MOD_BVALUES;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_MOD_DELETE"))
#ifdef LDAP_MOD_DELETE
	    return LDAP_MOD_DELETE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_MOD_REPLACE"))
#ifdef LDAP_MOD_REPLACE
	    return LDAP_MOD_REPLACE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_NAMING_VIOLATION"))
#ifdef LDAP_NAMING_VIOLATION
	    return LDAP_NAMING_VIOLATION;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_NOT_ALLOWED_ON_NONLEAF"))
#ifdef LDAP_NOT_ALLOWED_ON_NONLEAF
	    return LDAP_NOT_ALLOWED_ON_NONLEAF;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_NOT_ALLOWED_ON_RDN"))
#ifdef LDAP_NOT_ALLOWED_ON_RDN
	    return LDAP_NOT_ALLOWED_ON_RDN;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_NO_LIMIT"))
#ifdef LDAP_NO_LIMIT
	    return LDAP_NO_LIMIT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_NO_MEMORY"))
#ifdef LDAP_NO_MEMORY
	    return LDAP_NO_MEMORY;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_NO_OBJECT_CLASS_MODS"))
#ifdef LDAP_NO_OBJECT_CLASS_MODS
	    return LDAP_NO_OBJECT_CLASS_MODS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_NO_SUCH_ATTRIBUTE"))
#ifdef LDAP_NO_SUCH_ATTRIBUTE
	    return LDAP_NO_SUCH_ATTRIBUTE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_NO_SUCH_OBJECT"))
#ifdef LDAP_NO_SUCH_OBJECT
	    return LDAP_NO_SUCH_OBJECT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OBJECT_CLASS_VIOLATION"))
#ifdef LDAP_OBJECT_CLASS_VIOLATION
	    return LDAP_OBJECT_CLASS_VIOLATION;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPERATIONS_ERROR"))
#ifdef LDAP_OPERATIONS_ERROR
	    return LDAP_OPERATIONS_ERROR;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_CACHE_ENABLE"))
#ifdef LDAP_OPT_CACHE_ENABLE
	    return LDAP_OPT_CACHE_ENABLE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_CACHE_FN_PTRS"))
#ifdef LDAP_OPT_CACHE_FN_PTRS
	    return LDAP_OPT_CACHE_FN_PTRS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_CACHE_STRATEGY"))
#ifdef LDAP_OPT_CACHE_STRATEGY
	    return LDAP_OPT_CACHE_STRATEGY;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_DEREF"))
#ifdef LDAP_OPT_DEREF
	    return LDAP_OPT_DEREF;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_DESC"))
#ifdef LDAP_OPT_DESC
	    return LDAP_OPT_DESC;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_DNS"))
#ifdef LDAP_OPT_DNS
	    return LDAP_OPT_DNS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_IO_FN_PTRS"))
#ifdef LDAP_OPT_IO_FN_PTRS
	    return LDAP_OPT_IO_FN_PTRS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_OFF"))
#ifdef LDAP_OPT_OFF
	    return 0;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_ON"))
#ifdef LDAP_OPT_ON
	    return 1;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_REBIND_ARG"))
#ifdef LDAP_OPT_REBIND_ARG
	    return LDAP_OPT_REBIND_ARG;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_REBIND_FN"))
#ifdef LDAP_OPT_REBIND_FN
	    return LDAP_OPT_REBIND_FN;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_REFERRALS"))
#ifdef LDAP_OPT_REFERRALS
	    return LDAP_OPT_REFERRALS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_REFERRAL_HOP_LIMIT"))
#ifdef LDAP_OPT_REFERRAL_HOP_LIMIT
	    return LDAP_OPT_REFERRAL_HOP_LIMIT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_RESTART"))
#ifdef LDAP_OPT_RESTART
	    return LDAP_OPT_RESTART;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_SIZELIMIT"))
#ifdef LDAP_OPT_SIZELIMIT
	    return LDAP_OPT_SIZELIMIT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_SSL"))
#ifdef LDAP_OPT_SSL
	    return LDAP_OPT_SSL;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_THREAD_FN_PTRS"))
#ifdef LDAP_OPT_THREAD_FN_PTRS
	    return LDAP_OPT_THREAD_FN_PTRS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OPT_TIMELIMIT"))
#ifdef LDAP_OPT_TIMELIMIT
	    return LDAP_OPT_TIMELIMIT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_OTHER"))
#ifdef LDAP_OTHER
	    return LDAP_OTHER;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_PARAM_ERROR"))
#ifdef LDAP_PARAM_ERROR
	    return LDAP_PARAM_ERROR;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_PARTIAL_RESULTS"))
#ifdef LDAP_PARTIAL_RESULTS
	    return LDAP_PARTIAL_RESULTS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_PASCAL"))
#ifdef LDAP_PASCAL
	    return LDAP_PASCAL;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_PORT"))
#ifdef LDAP_PORT
	    return LDAP_PORT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_PORT_MAX"))
#ifdef LDAP_PORT_MAX
	    return LDAP_PORT_MAX;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_PROTOCOL_ERROR"))
#ifdef LDAP_PROTOCOL_ERROR
	    return LDAP_PROTOCOL_ERROR;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_REFERRAL"))
#ifdef LDAP_REFERRAL
	    return LDAP_REFERRAL;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_RESULTS_TOO_LARGE"))
#ifdef LDAP_RESULTS_TOO_LARGE
	    return LDAP_RESULTS_TOO_LARGE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_RES_ADD"))
#ifdef LDAP_RES_ADD
	    return LDAP_RES_ADD;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_RES_ANY"))
#ifdef LDAP_RES_ANY
	    return LDAP_RES_ANY;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_RES_BIND"))
#ifdef LDAP_RES_BIND
	    return LDAP_RES_BIND;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_RES_COMPARE"))
#ifdef LDAP_RES_COMPARE
	    return LDAP_RES_COMPARE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_RES_DELETE"))
#ifdef LDAP_RES_DELETE
	    return LDAP_RES_DELETE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_RES_EXTENDED"))
#ifdef LDAP_RES_EXTENDED
	    return LDAP_RES_EXTENDED;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_RES_MODIFY"))
#ifdef LDAP_RES_MODIFY
	    return LDAP_RES_MODIFY;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_RES_MODRDN"))
#ifdef LDAP_RES_MODRDN
	    return LDAP_RES_MODRDN;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_RES_RESUME"))
#ifdef LDAP_RES_RESUME
	    return LDAP_RES_RESUME;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_RES_SEARCH_ENTRY"))
#ifdef LDAP_RES_SEARCH_ENTRY
	    return LDAP_RES_SEARCH_ENTRY;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_RES_SEARCH_REFERENCE"))
#ifdef LDAP_RES_SEARCH_REFERENCE
	    return LDAP_RES_SEARCH_REFERENCE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_RES_SEARCH_RESULT"))
#ifdef LDAP_RES_SEARCH_RESULT
	    return LDAP_RES_SEARCH_RESULT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_RES_SESSION"))
#ifdef LDAP_RES_SESSION
	    return LDAP_RES_SESSION;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_SCOPE_BASE"))
#ifdef LDAP_SCOPE_BASE
	    return LDAP_SCOPE_BASE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_SCOPE_ONELEVEL"))
#ifdef LDAP_SCOPE_ONELEVEL
	    return LDAP_SCOPE_ONELEVEL;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_SCOPE_SUBTREE"))
#ifdef LDAP_SCOPE_SUBTREE
	    return LDAP_SCOPE_SUBTREE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_SECURITY_NONE"))
#ifdef LDAP_SECURITY_NONE
	    return LDAP_SECURITY_NONE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_SERVER_DOWN"))
#ifdef LDAP_SERVER_DOWN
	    return LDAP_SERVER_DOWN;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_SIZELIMIT_EXCEEDED"))
#ifdef LDAP_SIZELIMIT_EXCEEDED
	    return LDAP_SIZELIMIT_EXCEEDED;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_STRONG_AUTH_NOT_SUPPORTED"))
#ifdef LDAP_STRONG_AUTH_NOT_SUPPORTED
	    return LDAP_STRONG_AUTH_NOT_SUPPORTED;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_STRONG_AUTH_REQUIRED"))
#ifdef LDAP_STRONG_AUTH_REQUIRED
	    return LDAP_STRONG_AUTH_REQUIRED;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_SUCCESS"))
#ifdef LDAP_SUCCESS
	    return LDAP_SUCCESS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_TIMELIMIT_EXCEEDED"))
#ifdef LDAP_TIMELIMIT_EXCEEDED
	    return LDAP_TIMELIMIT_EXCEEDED;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_TIMEOUT"))
#ifdef LDAP_TIMEOUT
	    return LDAP_TIMEOUT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_TYPE_OR_VALUE_EXISTS"))
#ifdef LDAP_TYPE_OR_VALUE_EXISTS
	    return LDAP_TYPE_OR_VALUE_EXISTS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_UNAVAILABLE"))
#ifdef LDAP_UNAVAILABLE
	    return LDAP_UNAVAILABLE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_UNAVAILABLE_CRITICAL_EXTN"))
#ifdef LDAP_UNAVAILABLE_CRITICAL_EXTN
	    return LDAP_UNAVAILABLE_CRITICAL_EXTN;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_UNDEFINED_TYPE"))
#ifdef LDAP_UNDEFINED_TYPE
	    return LDAP_UNDEFINED_TYPE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_UNWILLING_TO_PERFORM"))
#ifdef LDAP_UNWILLING_TO_PERFORM
	    return LDAP_UNWILLING_TO_PERFORM;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_URL_ERR_BADSCOPE"))
#ifdef LDAP_URL_ERR_BADSCOPE
	    return LDAP_URL_ERR_BADSCOPE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_URL_ERR_MEM"))
#ifdef LDAP_URL_ERR_MEM
	    return LDAP_URL_ERR_MEM;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_URL_ERR_NODN"))
#ifdef LDAP_URL_ERR_NODN
	    return LDAP_URL_ERR_NODN;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_URL_ERR_NOTLDAP"))
#ifdef LDAP_URL_ERR_NOTLDAP
	    return LDAP_URL_ERR_NOTLDAP;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_URL_ERR_PARAM"))
#ifdef LDAP_URL_ERR_PARAM
	    return LDAP_URL_ERR_PARAM;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_URL_OPT_SECURE"))
#ifdef LDAP_URL_OPT_SECURE
	    return LDAP_URL_OPT_SECURE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_USER_CANCELLED"))
#ifdef LDAP_USER_CANCELLED
	    return LDAP_USER_CANCELLED;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_VERSION"))
#ifdef LDAP_VERSION
	    return LDAP_VERSION;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_VERSION1"))
#ifdef LDAP_VERSION1
	    return LDAP_VERSION1;
#else
	    goto not_there;
#endif
	if (strEQ(name, "LDAP_VERSION2"))
#ifdef LDAP_VERSION2
	    return LDAP_VERSION2;
#else
	    goto not_there;
#endif
	break;
    case 'M':
	break;
    case 'N':
	if (strEQ(name, "NBBY"))
#ifdef NBBY
	    return NBBY;
#else
	    goto not_there;
#endif
	if (strEQ(name, "NFDBITS"))
#ifdef NFDBITS
	    return NFDBITS;
#else
	    goto not_there;
#endif
	break;
    case 'O':
	break;
    case 'P':
	break;
    case 'Q':
	break;
    case 'R':
	break;
    case 'S':
	break;
    case 'T':
	break;
    case 'U':
	break;
    case 'V':
	break;
    case 'W':
	break;
    case 'X':
	break;
    case 'Y':
	break;
    case 'Z':
	break;
    case 'a':
	break;
    case 'b':
	break;
    case 'c':
	break;
    case 'd':
	break;
    case 'e':
	break;
    case 'f':
	break;
    case 'g':
	break;
    case 'h':
	break;
    case 'i':
	break;
    case 'j':
	break;
    case 'k':
	break;
    case 'l':
	break;
    case 'm':
	break;
    case 'n':
	break;
    case 'o':
	break;
    case 'p':
	break;
    case 'q':
	break;
    case 'r':
	break;
    case 's':
	break;
    case 't':
	break;
    case 'u':
	break;
    case 'v':
	break;
    case 'w':
	break;
    case 'x':
	break;
    case 'y':
	break;
    case 'z':
	break;
    case '_':
	break;
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}


static
LDAPMod ** hash2add(HV *ldap_change)
{
           LDAPMod **ldapmod;
           LDAPMod current_mod;
           int value_count = 0, ldap_attribute_count = 0;
           HE *ldap_change_element;
           char *ldap_current_attribute;
           SV *ldap_current_value_sv, *ldap_current_value_sv2;
           I32 keylen,ldap_arraylen;
	   int add;

           hv_iterinit(ldap_change);
           while((ldap_change_element = hv_iternext(ldap_change)) != NULL)
           {
              ldap_current_attribute = hv_iterkey(ldap_change_element,&keylen);
              ldap_current_value_sv = hv_iterval(ldap_change,ldap_change_element);
	      add = 0;
              if (SvTYPE(SvRV(ldap_current_value_sv)) == SVt_PVAV)
              {
                 ldap_arraylen = av_len((AV *)SvRV(ldap_current_value_sv));
                 if (ldap_arraylen >= 0)
                 {
	            add = 1;
                    current_mod.mod_op = 0;
                    current_mod.mod_type = ldap_current_attribute;
                    current_mod.mod_values = (char **)calloc(2+ldap_arraylen,sizeof(char *));
                    for (value_count=0;value_count<=ldap_arraylen;value_count++)
                    {
                       ldap_current_value_sv2 = av_shift((AV *)SvRV(ldap_current_value_sv));
                       current_mod.mod_values[value_count] = SvPV(ldap_current_value_sv2,na);
                    }
                    current_mod.mod_values[value_count] = NULL;
                 }
              } else {
                 if (strcmp(SvPV(ldap_current_value_sv,na),"") != 0)
                 {
	            add = 1;
                    current_mod.mod_op = 0;
                    current_mod.mod_type = ldap_current_attribute;
                    current_mod.mod_values = (char **)calloc(2,sizeof(char *));
                    current_mod.mod_values[0] = SvPV(ldap_current_value_sv,na);
                    current_mod.mod_values[1] = NULL;
                 }
              }
	      if (add == 1)
	      {
                 ldap_attribute_count = ldap_attribute_count + 1;
                 ldapmod = (LDAPMod **)realloc(ldapmod,(1+ldap_attribute_count)*sizeof(LDAPMod *));
                 ldapmod[ldap_attribute_count - 1] = (LDAPMod *)malloc(sizeof(current_mod));
                 memcpy(ldapmod[ldap_attribute_count-1],&current_mod,sizeof(current_mod));
	      }
           }
           ldapmod[ldap_attribute_count] = NULL;
           return ldapmod;
}

static
LDAPMod ** hash2mod(HV *ldap_change)
{
           LDAPMod **ldapmod;
           LDAPMod current_mod;
           int value_count = 0, ldap_attribute_count = 0;
           HE *ldap_change_element;
           char *ldap_current_attribute;
           SV *ldap_current_value_sv, *ldap_current_value_sv2;
           I32 keylen,ldap_arraylen;

           hv_iterinit(ldap_change);
           while((ldap_change_element = hv_iternext(ldap_change)) != NULL)
           {
              ldap_current_attribute = hv_iterkey(ldap_change_element,&keylen);
              ldap_current_value_sv = hv_iterval(ldap_change,ldap_change_element);
              if (SvTYPE(SvRV(ldap_current_value_sv)) == SVt_PVAV)
              {
                 ldap_arraylen = av_len((AV *)SvRV(ldap_current_value_sv));
                 if (ldap_arraylen < 0)
                 {
                    current_mod.mod_op = LDAP_MOD_DELETE;
                    current_mod.mod_type = ldap_current_attribute;
                    current_mod.mod_values = NULL;
                 } else {
                    current_mod.mod_op = LDAP_MOD_REPLACE;
                    current_mod.mod_type = ldap_current_attribute;
                    current_mod.mod_values = (char **)calloc(2+ldap_arraylen,sizeof(char *));
                    for (value_count=0;value_count<=ldap_arraylen;value_count++)
                    {
                       ldap_current_value_sv2 = av_shift((AV *)SvRV(ldap_current_value_sv));
                       current_mod.mod_values[value_count] = SvPV(ldap_current_value_sv2,na);
                    }
                    current_mod.mod_values[value_count] = NULL;
                 }
              } else {
                 if (strcmp(SvPV(ldap_current_value_sv,na),"") == 0)
                 {
                    current_mod.mod_op = LDAP_MOD_DELETE;
                    current_mod.mod_type = ldap_current_attribute;
                    current_mod.mod_values = NULL;
                 } else {
                    current_mod.mod_op = LDAP_MOD_REPLACE;
                    current_mod.mod_type = ldap_current_attribute;
                    current_mod.mod_values = (char **)calloc(2,sizeof(char *));
                    current_mod.mod_values[0] = SvPV(ldap_current_value_sv,na);
                    current_mod.mod_values[1] = NULL;
                 }
              }
              ldap_attribute_count = ldap_attribute_count + 1;
              ldapmod = (LDAPMod **)realloc(ldapmod,(1+ldap_attribute_count)*sizeof(LDAPMod *));
              ldapmod[ldap_attribute_count - 1] = (LDAPMod *)malloc(sizeof(current_mod));
              memcpy(ldapmod[ldap_attribute_count-1],&current_mod,sizeof(current_mod));
           }
           ldapmod[ldap_attribute_count] = NULL;
	   return ldapmod;
}

MODULE = Net::LDAPapi           PACKAGE = Net::LDAPapi


double
constant(name,arg)
        char *          name
        int             arg


LDAP *
ldap_open(host,port)
	LDAP_CHAR *	host
	int		port
	OUTPUT:
	RETVAL

LDAP *
ldap_init(defhost,defport)
	LDAP_CHAR *	defhost
	int		defport
	OUTPUT:
	RETVAL

#ifdef NETSCAPE_LDAP

int
ldap_set_option(ld,option,optdata)
	LDAP *		ld
	int		option
	int		optdata
	CODE:
	{
	   ldap_set_option(ld,option,&optdata);
	}
	OUTPUT:
	RETVAL

int
ldap_get_option(ld,option,optdata)
	LDAP *		ld
	int		option
	int		optdata
	CODE:
	{
	   ldap_get_option(ld,option,&optdata);
	}
	OUTPUT:
	RETVAL
	optdata

#endif

int
ldap_unbind(ld)
	LDAP *		ld
	OUTPUT:
	RETVAL
	
int
ldap_unbind_s(ld)
	LDAP *		ld
	OUTPUT:
	RETVAL

#ifdef NETSCAPE_LDAP

int
ldap_version(ver)
	LDAPVersion	*ver
	OUTPUT:
	RETVAL

#endif

int
ldap_abandon(ld,msgid)
	LDAP *		ld
	int		msgid
	OUTPUT:
	RETVAL

int
ldap_add(ld,dn,ldap_change_ref)
	LDAP *		ld
	LDAP_CHAR *	dn
	SV *		ldap_change_ref
        CODE:
        {
           LDAPMod **mods;

           if (SvTYPE(SvRV(ldap_change_ref)) != SVt_PVHV)
           {
              croak("Expected Reference to Hash for Argument 3.");
              XSRETURN(1);
           }
           mods = hash2add((HV *)SvRV(ldap_change_ref));
	   RETVAL = ldap_add(ld,dn,mods);
	   free(mods);
	}
	OUTPUT:
	RETVAL

int
ldap_add_s(ld,dn,ldap_change_ref)
	LDAP *		ld
	LDAP_CHAR *	dn
	SV *		ldap_change_ref
	CODE:
	{
           LDAPMod **mods;

           if (SvTYPE(SvRV(ldap_change_ref)) != SVt_PVHV)
           {
              croak("Expected Reference to Hash for Argument 3.");
              XSRETURN(1);
           }
           mods = hash2add((HV *)SvRV(ldap_change_ref));
	   RETVAL = ldap_add_s(ld,dn,mods);
	   free(mods);
	}
	OUTPUT:
	RETVAL

int
ldap_bind(ld,who,passwd,type)
	LDAP *		ld
	LDAP_CHAR *	who
	LDAP_CHAR *	passwd
	int		type
	OUTPUT:
	RETVAL

int
ldap_bind_s(ld,who,passwd,type)
	LDAP *		ld
	LDAP_CHAR *	who
	LDAP_CHAR *	passwd
	int		type
	OUTPUT:
	RETVAL

int
ldap_simple_bind(ld,who,passwd)
	LDAP *		ld
	LDAP_CHAR *	who
	LDAP_CHAR *	passwd
	OUTPUT:
	RETVAL

int
ldap_simple_bind_s(ld,who,passwd)
	LDAP *		ld
	LDAP_CHAR *	who
	LDAP_CHAR *	passwd
	OUTPUT:
	RETVAL

int
ldap_modify(ld,dn,ldap_change_ref)
	LDAP *		ld
	LDAP_CHAR *	dn
	SV *		ldap_change_ref
	CODE:
	{
           LDAPMod **mods;

           if (SvTYPE(SvRV(ldap_change_ref)) != SVt_PVHV)
           {
              croak("Expected Reference to Hash for Argument 3.");
              XSRETURN(1);
           }
           mods = hash2mod((HV *)SvRV(ldap_change_ref));
           RETVAL = ldap_modify(ld,dn,mods);
           free(mods);
	}
	OUTPUT:
	RETVAL

int
ldap_modify_s(ld,dn,ldap_change_ref)
	LDAP *		ld
	LDAP_CHAR *	dn
        SV *		ldap_change_ref
	CODE:
	{
           LDAPMod **mods;

	   if (SvTYPE(SvRV(ldap_change_ref)) != SVt_PVHV)
	   {
              croak("Expected Reference to Hash for Argument 3.");
              XSRETURN(1);
	   }
	   mods = hash2mod((HV *)SvRV(ldap_change_ref));
	   RETVAL = ldap_modify_s(ld,dn,mods);
	   free(mods);
	}
	OUTPUT:
	RETVAL

int
ldap_modrdn(ld,dn,newrdn)
	LDAP *		ld
	LDAP_CHAR *	dn
	LDAP_CHAR *	newrdn
	OUTPUT:
	RETVAL

int
ldap_modrdn_s(ld,dn,newrdn)
	LDAP *		ld
	LDAP_CHAR *	dn
	LDAP_CHAR *	newrdn
	OUTPUT:
	RETVAL

int
ldap_modrdn2(ld,dn,newrdn,deleteoldrdn)
	LDAP *		ld
	LDAP_CHAR *	dn
	LDAP_CHAR *	newrdn
	int		deleteoldrdn
	OUTPUT:
	RETVAL

int
ldap_modrdn2_s(ld,dn,newrdn,deleteoldrdn)
	LDAP *		ld
	LDAP_CHAR *	dn
	LDAP_CHAR *	newrdn
	int		deleteoldrdn
	OUTPUT:
	RETVAL

int
ldap_compare(ld,dn,attr,value)
	LDAP *		ld
	LDAP_CHAR *	dn
	LDAP_CHAR *	attr
	LDAP_CHAR *	value
	OUTPUT:
	RETVAL

int
ldap_compare_s(ld,dn,attr,value)
	LDAP *		ld
	LDAP_CHAR *	dn
	LDAP_CHAR *	attr
	LDAP_CHAR *	value
	OUTPUT:
	RETVAL

int
ldap_delete(ld,dn)
	LDAP *		ld
	LDAP_CHAR *	dn
	OUTPUT:
	RETVAL

int
ldap_delete_s(ld,dn)
	LDAP *		ld
	LDAP_CHAR *	dn
	OUTPUT:
	RETVAL

int
ldap_search(ld,base,scope,filter,attrs,attrsonly)
	LDAP *		ld
	LDAP_CHAR *	base
	int		scope
	LDAP_CHAR *	filter
	SV *		attrs
	int		attrsonly
	CODE:
	{
           char **attrs_char;
           SV *current;
           int arraylen,count;

           if (SvTYPE(SvRV(attrs)) != SVt_PVAV)
           {
              croak("Expected Reference to Array for Argument 5.");
              XSRETURN(1);
           }
           if ((arraylen = av_len((AV *)SvRV(attrs))) < 0)
           {
              attrs_char = (char **)malloc(2);
              attrs_char[0] = NULL;
           } else {
              attrs_char = (char **)malloc(arraylen+2);
              for (count=0;count <= arraylen; count++)
              {
                 current = av_shift((AV *)SvRV(attrs));
                 attrs_char[count] = SvPV(current,na);
              }
              attrs_char[arraylen+1] = NULL;
           }
	   RETVAL = ldap_search(ld,base,scope,filter,attrs_char,attrsonly);
	   free(attrs_char);
	}
	OUTPUT:
	RETVAL

int
ldap_search_s(ld,base,scope,filter,attrs,attrsonly,res)
	LDAP *		ld
	LDAP_CHAR *	base
	int		scope
	LDAP_CHAR *	filter
	SV *		attrs
        int     	attrsonly
        LDAPMessage *   res
	CODE:
	{
	   char **attrs_char;
	   SV *current;
	   int arraylen,count;

	   if (SvTYPE(SvRV(attrs)) == SVt_PVAV)
	   {
	      if ((arraylen = av_len((AV *)SvRV(attrs))) < 0)
	      {
	         attrs_char = (char **)malloc(2);
	         attrs_char[0] = NULL;
	      } else {
	         attrs_char = (char **)malloc(arraylen+2);
	         for (count=0;count <= arraylen; count++)
	         {
	            current = av_shift((AV *)SvRV(attrs));
	            attrs_char[count] = SvPV(current,na);
	         }
	         attrs_char[arraylen+1] = NULL;
	      }
	   } else {
	      croak("Expected Reference to Array for Argument 5.");
	      XSRETURN(1);
	   }
	   RETVAL = ldap_search_s(ld,base,scope,filter,attrs_char,attrsonly,&res);
	   free(attrs_char);
	}
	OUTPUT:
	RETVAL
	res

int
ldap_search_st(ld,base,scope,filter,attrs,attrsonly,timeout,res)
	LDAP *          ld
	LDAP_CHAR *    base
	int             scope
	LDAP_CHAR *    filter
	SV *		attrs
	int             attrsonly
	LDAP_CHAR *	timeout
	LDAPMessage *   res
	CODE:
	{
	   struct timeval *tv_timeout;
           char **attrs_char;
           SV *current;
           int arraylen,count;

           if (SvTYPE(SvRV(attrs)) != SVt_PVAV)
           {
              croak("Expected Reference to Array for Argument 5.");
              XSRETURN(1);
           }
           if ((arraylen = av_len((AV *)SvRV(attrs))) < 0)
           {
              attrs_char = (char **)malloc(2);
              attrs_char[0] = NULL;
           } else {
              attrs_char = (char **)malloc(arraylen+2);
              for (count=0;count <= arraylen; count++)
              {
                 current = av_shift((AV *)SvRV(attrs));
                 attrs_char[count] = SvPV(current,na);
              }
              attrs_char[arraylen+1] = NULL;
           }
	   tv_timeout->tv_sec = atof(timeout);
	   tv_timeout->tv_usec = 0;
	   RETVAL = ldap_search_st(ld,base,scope,filter,attrs_char,attrsonly,tv_timeout,&res);
	}
	OUTPUT:
	RETVAL
	res

int
ldap_result(ld,msgid,all,timeout,result)
	LDAP *		ld
	int		msgid
	int		all
	LDAP_CHAR *	timeout
	LDAPMessage *	result
	CODE:
	{
	   struct timeval tv_timeout;
	   if (atof(timeout) < 0)
	   {
	      RETVAL = ldap_result(ld,msgid,all,NULL,&result);
	   }
	   else
	   {
	      tv_timeout.tv_sec = atof(timeout);
	      tv_timeout.tv_usec = 0;
	      RETVAL = ldap_result(ld,msgid,all,&tv_timeout,&result);
	   }
	}
	OUTPUT:
	RETVAL
	result

int
ldap_msgfree(lm)
	LDAPMessage *	lm
	OUTPUT:
	RETVAL

void
ldap_mods_free(mods,freemods)
	LDAPMod *	mods
	int		freemods
	CODE:
	{
	   ldap_mods_free(&mods,freemods);
	}

#ifdef NETSCAPE_LDAP

int
ldap_msgid(lm)
	LDAPMessage *	lm
	OUTPUT:
	RETVAL

int
ldap_msgtype(lm)
	LDAPMessage *	lm

int
ldap_get_lderrno(ld,m,s)
	LDAP *		ld
	char *		m
	char *		s
	CODE:
	{
	   RETVAL = ldap_get_lderrno(ld,&m,&s);
	}
	OUTPUT:
	RETVAL
	m
	s

int
ldap_set_lderrno(ld,e,m,s)
	LDAP *		ld
	int		e
	char *		m
	char *		s
	OUTPUT:
	RETVAL

#endif

int
ldap_result2error(ld,r,freeit)
	LDAP *		ld
	LDAPMessage *	r
	int		freeit
	OUTPUT:
	RETVAL

char *
ldap_err2string(err)
	int err
	OUTPUT:
	RETVAL

int
ldap_count_entries(ld,result)
	LDAP *		ld
	LDAPMessage *	result
	OUTPUT:
	RETVAL

LDAPMessage *
ldap_first_entry(ld,result)
	LDAP *		ld
	LDAPMessage *	result
	OUTPUT:
	RETVAL

LDAPMessage *
ldap_next_entry(ld,preventry)
	LDAP *		ld
	LDAPMessage *	preventry
	OUTPUT:
	RETVAL

char *
ldap_get_dn(ld,entry)
	LDAP *		ld
	LDAPMessage *	entry
	OUTPUT:
	RETVAL

void
ldap_perror(ld,s)
	LDAP *		ld
	LDAP_CHAR *	s


char *
ldap_dn2ufn(dn)
	LDAP_CHAR *	dn
	OUTPUT:
	RETVAL

#ifdef NETSCAPE_LDAP

void
ldap_explode_dn(dn,notypes)
	char *		dn
	int		notypes
	PPCODE:
	{
	   char ** LDAPGETVAL;
	   int i;

	   if ((LDAPGETVAL = ldap_explode_dn(dn,notypes)) != NULL)
	   {
	       for (i = 0; LDAPGETVAL[i] != NULL; i++)
	       {
	          EXTEND(sp,1);
	          PUSHs(sv_2mortal(newSVpv(LDAPGETVAL[i],strlen(LDAPGETVAL[i]))));
	       }
	   }
	}

void
ldap_explode_rdn(dn,notypes)
	char *		dn
	int	notypes
	PPCODE:
	{
	   char ** LDAPGETVAL;
	   int i;

	   if ((LDAPGETVAL = ldap_explode_rdn(dn,notypes)) != NULL)
	   {
	       for (i = 0; LDAPGETVAL[i] != NULL; i++)
	       {
	          EXTEND(sp,1);
	          PUSHs(sv_2mortal(newSVpv(LDAPGETVAL[i],strlen(LDAPGETVAL[i]))));
	       }
	   }
	}

void
ldap_explode_dns(dn)
	char *          dn
	PPCODE:
	{
	   char ** LDAPGETVAL;
	   int i;

	   if ((LDAPGETVAL = ldap_explode_dns(dn)) != NULL)
	   {
	       for (i = 0; LDAPGETVAL[i] != NULL; i++)
	       {
	          EXTEND(sp,1);
	          PUSHs(sv_2mortal(newSVpv(LDAPGETVAL[i],strlen(LDAPGETVAL[i]))));
	       }
	   }
	}

#endif

char *
ldap_first_attribute(ld,entry,ber)
	LDAP *		ld
	LDAPMessage *	entry
	BerElement *	ber
	CODE:
	{
	   RETVAL = ldap_first_attribute(ld,entry,&ber);
	}
	OUTPUT:
	RETVAL
	ber

char *
ldap_next_attribute(ld,entry,ber)
	LDAP *		ld
	LDAPMessage *	entry
	BerElement *	ber
	OUTPUT:
	RETVAL
	ber


void
ldap_get_values(ld,entry,attr)
	LDAP *		ld
	LDAPMessage *	entry
	char *		attr
	PPCODE:
	{
	   char ** LDAPGETVAL;
	   int i;

           if ((LDAPGETVAL = ldap_get_values(ld,entry,attr)) != NULL)
	   {
	       for (i = 0; LDAPGETVAL[i] != NULL; i++)
	       {
	          EXTEND(sp,1);
	          PUSHs(sv_2mortal(newSVpv(LDAPGETVAL[i],strlen(LDAPGETVAL[i]))));
	       }
	   }
	}

struct berval **
ldap_get_values_len(ld,entry,attr)
	LDAP *		ld
	LDAPMessage *	entry
	char *		attr
	OUTPUT:
	RETVAL


#ifdef NETSCAPE_LDAP

void
ldap_ber_free(ber,freebuf)
	BerElement *	ber
	int		freebuf

#endif

int
ldap_count_values_len(vals)
	struct berval **	vals
	OUTPUT:
	RETVAL

void
ldap_value_free_len(vals)
	struct berval **	vals

